## massxpert3 10.4.0

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.18.4)

############################################################
############################################################
# Basic information about project

# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN32 if SYSTEM_UNAME_S is "^.*MING64.*"
# Note that WIN32 is set even on 64 bits systems.
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

# Compute the extended version number using git describe
include(${CMAKE_UTILS_PATH}/extended-version.cmake)

message("GIT_RECORD_IDENTIFIER: ${GIT_RECORD_IDENTIFIER}")

project(
    MassXpert3
    VERSION 10.4.0
    DESCRIPTION "A program to model and simulate mass spectra on linear (bio-)polymers"
    HOMEPAGE_URL "http://wwww.msxpertsuite.org/massxpert3"
)

set(LOWCASE_PROJECT_NAME massxpert3)
set(LOWCASE_PROJECT_NAME_NO_VER massxpert)

set(TARGET ${PROJECT_NAME})

# project(VERSION) above sets: PROJECT_VERSION, <PROJECT-NAME>_VERSION
# PROJECT_VERSION_MAJOR, <PROJECT-NAME>_VERSION_MAJOR PROJECT_VERSION_MINOR,
# <PROJECT-NAME>_VERSION_MINOR PROJECT_VERSION_PATCH,
# <PROJECT-NAME>_VERSION_PATCH

# Set additional project information
set(COMPANY "MsXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2008-2025 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")

#############################################################
#############################################################
# Installation prefix (these lines before include(GNUInstallDirs))
if(NOT CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX /usr/local)
endif()

include(GNUInstallDirs)

message(STATUS: CMAKE_CXX_LIBRARY_ARCHITECTURE is: ${CMAKE_CXX_LIBRARY_ARCHITECTURE})

set(HOME_DEVEL_DIR $ENV{HOME}/devel)

# Our build scripts take for granted that this files is available.
configure_file(${CMAKE_UTILS_PATH}/version.cmake.in ${CMAKE_BINARY_DIR}/version.txt)

# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
include_directories(${CMAKE_BINARY_DIR})

# And now the source directory contains the .h|.hpp files for its .cpp files.
include_directories(${CMAKE_SOURCE_DIR})

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldGreen}Beginning configuration for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin) and by the Clang-based code analyzer.
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json")
    execute_process(
        COMMAND cmake -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
                ${CMAKE_SOURCE_DIR}/compile_commands.json
    )
endif()

# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message(STATUS "Setting definition -Wall -pedantic.")
add_definitions(-Wall -pedantic)
message(STATUS "Setting definition -Wextra.")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
    message(STATUS "Setting definition -Werror.")
    add_definitions(-Werror)
endif()

message("CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}")

option(MXE "Use the cross-compiling environment MXE" OFF)

option(PAPPSO_LOCAL_DEV "Use locally developped libpappsomspp" OFF)
option(PAPPSO_LOCAL_INST "Use /usr/local/lib installed libpappsomspp" OFF)

if(PAPPSO_LOCAL_DEV AND PAPPSO_LOCAL_INST)
    message(FATAL_ERROR "Cannot have both PAPPSO_LOCAL_DEV and PAPPSO_LOCAL_INST")
endif()

message(STATUS "PAPPSO_LOCAL_DEV: ${PAPPSO_LOCAL_DEV}")
message(STATUS "PAPPSO_LOCAL_INST: ${PAPPSO_LOCAL_INST}")

option(XPERTMASS_LOCAL_DEV "Use locally developped libXpertMass" OFF)
option(XPERTMASS_LOCAL_INST "Use /usr/local/lib installed libXpertMass" OFF)

if(XPERTMASS_LOCAL_DEV AND XPERTMASS_LOCAL_INST)
    message(FATAL_ERROR "Cannot have both XPERTMASS_LOCAL_DEV and XPERTMASS_LOCAL_INST")
endif()

message(STATUS "XPERTMASS_LOCAL_DEV: ${XPERTMASS_LOCAL_DEV}")
message(STATUS "XPERTMASS_LOCAL_INST: ${XPERTMASS_LOCAL_INST}")

option(PROFILING Off)
if(PROFILING)
    message(STATUS "${BoldYellow}Profiling is requested, adding -pg -g flags.${ColourReset}")
    add_definitions(-pg -g)
endif()

#############################################################
#############################################################
# Platform-specific CMake configuration
if(WIN32 OR _WIN32)

    if(MXE)

        # Run the following cmake command line:
        # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development
        include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)

        # Set the name to the systemUname variable because in this situation that name
        # is not found, it it passed as a flag in the command line.
        set(SYSTEM_UNAME_S "mxe")

    elseif(WIN10UCRT64)
        include(${CMAKE_TOOLCHAINS_PATH}/win10-ucrt64-toolchain.cmake)
    endif()

elseif(UNIX)

    message("UNIX toolchain being selected")

    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-common.cmake)

endif()

message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")

#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE
        Release
        CACHE STRING "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel." FORCE
    )
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
    message(STATUS "Compiling in release mode.")
    add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
    message(STATUS "Compiling in debug mode.")
    message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
    add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
    message(STATUS "Compiling in release with debug info mode.")
endif()

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")

if(PROFILE)
    message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
    add_definitions(-pg)
endif()

message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

# It is essential to run these config steps before delving into the massxpert
# directory, because at that moment they will need what are
# going to prepare right now.
configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX)
    execute_process(
        COMMAND rsvg-convert -f png -o ${CMAKE_SOURCE_DIR}/images/splashscreen.png
                ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg
    )
endif()

#############################################################
######################
# BUILD OF THE PROGRAM

add_subdirectory(src)

#############################################################
###################
# BUILD OF THE DATA
add_subdirectory(data)

#############################################################
################################
# BUILD OF THE DOC / USER MANUAL
option(BUILD_USER_MANUAL "Build the user manual, on UNIX only." OFF)
message(STATUS "Adding subdirectory doc for project: ${TARGET}")
add_subdirectory(doc)

# Use all the configured paths to create the config.h file.
# The config file is binary directory-specific !!!
get_property(PappsoMS_ACTIVE_DIR_PATH GLOBAL PROPERTY PappsoMS_ACTIVE_DIR_PATH)

configure_file(${CMAKE_UTILS_PATH}/config.h.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/src/config.h @ONLY)

####################################################
# Installation directories depending on the platform
####################################################

# See the CMakeStuff/toolchains platform-specific files.
# See the CMakeStuff/toolchains platform-specific files.
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "PROJECT_INSTALL_BIN_DIR: ${PROJECT_INSTALL_BIN_DIR}")
message(STATUS "PROJECT_INSTALL_LIB_DIR: ${PROJECT_INSTALL_LIB_DIR}")
message(STATUS "PROJECT_INSTALL_DATA_DIR: ${PROJECT_INSTALL_DATA_DIR}")
message(STATUS "PROJECT_INSTALL_CHEMDATA_DIR: ${PROJECT_INSTALL_CHEMDATA_DIR}")
message(STATUS "PROJECT_INSTALL_DOC_DIR: ${PROJECT_INSTALL_DOC_DIR}")

#############################################################
###########################
# CREATE THE SOURCE PACKAGE
include(${CMAKE_UTILS_PATH}/targz-source-package-creation.cmake)

add_custom_target(
    archive
    cpack
    -G
    TGZ
    --config
    CPackSourceConfig.cmake
    &&
    mv
    ${CMAKE_BINARY_DIR}/${LOWCASE_PROJECT_NAME}-${PROJECT_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../tarballs
    &&
    ln
    -sf
    ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${PROJECT_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../${LOWCASE_PROJECT_NAME}_${PROJECT_VERSION}.orig.tar.gz
    &&
    ln
    -sf
    ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${PROJECT_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}_${PROJECT_VERSION}.orig.tar.gz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating .tar.gz"
    VERBATIM
)

#############################################################
# summary
message("")
message(STATUS "${BoldGreen}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldGreen}   General configuration of the ${CMAKE_PROJECT_NAME} project ${ColourReset}")
message("")

message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_STANDARD: ${CMAKE_CXX_STANDARD}${ColourReset}")

message("")

message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message(STATUS "${BoldYellow}TARGET: ${TARGET}${ColourReset}")
message(STATUS "${BoldYellow}PROJECT_INSTALL_BIN_DIR: ${PROJECT_INSTALL_BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}DOC_DIR: ${DOC_DIR}${ColourReset}")

if(PROFILING)
    message(STATUS "${BoldYellow}Profiling is requested (-DPROFILING=1)${ColourReset}")
else()
    message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILING=0)${ColourReset}")
endif()

if(WARNASERR)
    message(STATUS "${BoldYellow}Warnings ARE treated as errors (-DWARNASERR=1)${ColourReset}")
else()
    message(STATUS "${BoldYellow}Warnings NOT treated as errors (-DWARNASERR=0)${ColourReset}")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    message(STATUS "${BoldYellow}Debug support IS requested.${ColourReset}")
else()
    message(STATUS "${BoldYellow}Debug support NOT requested.${ColourReset}")
endif()

message("")
message(
    STATUS
        "${BoldYellow}The typical cmake invocation on Debian GNU/Linux would be: cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development${ColourReset}"
)
message(
    STATUS

=== data/CMakeLists.txt ===
message("\n${BoldGreen}Beginning configuration for subdirectory data${ColourReset}\n")


message("\n${BoldGreen}Installation directory for the data files: ${PROJECT_INSTALL_CHEMDATA_DIR}${ColourReset}\n")

INSTALL (DIRECTORY polChemDefs polSeqs dictionaries
	DESTINATION ${PROJECT_INSTALL_CHEMDATA_DIR})

INSTALL (FILES chemPad.conf
	DESTINATION ${PROJECT_INSTALL_CHEMDATA_DIR})

message("\n${BoldGreen}Ending configuration for subdirectory data${ColourReset}\n")

=== doc/CMakeLists.txt ===
message("\n${BoldGreen}Beginning configuration for subdirectory doc${ColourReset}\n")

# The UNIX man pages
if(UNIX AND NOT APPLE)

  message("\n${BoldYellow}Generating the man page.${ColourReset}\n")

  execute_process(COMMAND docbook-to-man ${PROJECT_NAME}.xml
    OUTPUT_FILE	${CMAKE_BINARY_DIR}/${PROJECT_NAME}.1
    WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

endif()


###############
# install stuff

# The history and licence files.

message("\n${BoldGreen}Installation directory for the doc files: ${PROJECT_INSTALL_DOC_DIR}${ColourReset}\n")

install(FILES history.html ../LICENSE
  DESTINATION ${PROJECT_INSTALL_DOC_DIR})

# The man page.
if(UNIX AND NOT APPLE)
  install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.1
    DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1)
endif()


#############################################################
###########################
# BUILD OF THE USER MANUAL

# The version of the program needs to be set in the user manual front
# matter. We need to make this configuration even if we do not build the
# user manual because when building debian packages the source tarball
# needs to have the right version in the file.
configure_file(
    ${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.cmake.in
    ${CMAKE_SOURCE_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY
)

if(UNIX AND BUILD_USER_MANUAL)
  add_subdirectory(user-manual)
endif()

message("\n${BoldGreen}Ending configuration for subdirectory doc${ColourReset}\n")

=== src/CMakeLists.txt ===
message("\n${BoldGreen}Beginning configuration for subdirectory src${ColourReset}\n")

set(NONGUI_DIR ${CMAKE_CURRENT_SOURCE_DIR}/nongui)
set(GUI_DIR ${CMAKE_CURRENT_SOURCE_DIR}/gui)

########################################################
# Files
set(${TARGET}_nongui_SRCS
    ${NONGUI_DIR}/globals.cpp
    ${NONGUI_DIR}/PolChemDefCatParser.cpp
    ${NONGUI_DIR}/ConfigSetting.cpp
    ${NONGUI_DIR}/ConfigSettings.cpp
    ${NONGUI_DIR}/UserSpec.cpp
)

set(${TARGET}_gui_SRCS
    ${GUI_DIR}/AboutDlg.cpp
    ${GUI_DIR}/Application.cpp
    ${GUI_DIR}/ApplicationPreferencesWnd.cpp
    ${GUI_DIR}/ProgramWindow.cpp
    ${GUI_DIR}/SequenceEditorWnd.cpp
    ${GUI_DIR}/AbstractMainTaskWindow.cpp
    ${GUI_DIR}/AbstractPolChemDefDependentDlg.cpp
    ${GUI_DIR}/AbstractSeqEdWndDependentDlg.cpp
    ${GUI_DIR}/ChemEntVignette.cpp
    ${GUI_DIR}/MonomerSpec.cpp
    ${GUI_DIR}/ModifSpec.cpp
    ${GUI_DIR}/CrossLinkerSpec.cpp
    ${GUI_DIR}/CalculatorChemPadDlg.cpp
    ${GUI_DIR}/CalculatorChemPadGroupBox.cpp
    ${GUI_DIR}/CalculatorRecorderDlg.cpp
    ${GUI_DIR}/CalculatorWnd.cpp
    ${GUI_DIR}/ChemPadButton.cpp
    ${GUI_DIR}/CleavageDlg.cpp
    ${GUI_DIR}/CleaveOligomerTableView.cpp
    ${GUI_DIR}/CleaveOligomerTableViewMimeData.cpp
    ${GUI_DIR}/CleaveOligomerTableViewModel.cpp
    ${GUI_DIR}/CleaveOligomerTableViewSortProxyModel.cpp
    ${GUI_DIR}/CleavageAgentDefDlg.cpp
    ${GUI_DIR}/CompositionTreeView.cpp
    ${GUI_DIR}/CompositionTreeViewItem.cpp
    ${GUI_DIR}/CompositionTreeViewModel.cpp
    ${GUI_DIR}/CompositionTreeViewSortProxyModel.cpp
    ${GUI_DIR}/CompositionsDlg.cpp
    ${GUI_DIR}/CrossLinkerDefDlg.cpp
    ${GUI_DIR}/FileSystemHierarchyPreferencesWidget.cpp
    ${GUI_DIR}/FragmentationPathwayDefDlg.cpp
    ${GUI_DIR}/FragmentOligomerTableView.cpp
    ${GUI_DIR}/FragmentOligomerTableViewMimeData.cpp
    ${GUI_DIR}/FragmentOligomerTableViewModel.cpp
    ${GUI_DIR}/FragmentOligomerTableViewSortProxyModel.cpp
    ${GUI_DIR}/FragmentationDlg.cpp
    ${GUI_DIR}/IsotopeDefDlg.cpp
    ${GUI_DIR}/MassListSorterDlg.cpp
    ${GUI_DIR}/MassSearchDlg.cpp
    ${GUI_DIR}/MassSearchOligomerTableView.cpp
    ${GUI_DIR}/MassSearchOligomerTableViewMimeData.cpp
    ${GUI_DIR}/MassSearchOligomerTableViewModel.cpp
    ${GUI_DIR}/MassSearchOligomerTableViewSortProxyModel.cpp
    ${GUI_DIR}/ModifDefDlg.cpp
    ${GUI_DIR}/MonomerCodeEvaluator.cpp
    ${GUI_DIR}/MonomerCrossLinkDlg.cpp
    ${GUI_DIR}/MonomerDefDlg.cpp
    ${GUI_DIR}/MonomerModificationDlg.cpp
    ${GUI_DIR}/MzCalculationDlg.cpp
    ${GUI_DIR}/MzCalculationTreeView.cpp
    ${GUI_DIR}/MzCalculationTreeViewItem.cpp
    ${GUI_DIR}/MzCalculationTreeViewModel.cpp
    ${GUI_DIR}/MzCalculationTreeViewSortProxyModel.cpp
    ${GUI_DIR}/PkaPhPiDlg.cpp
    ${GUI_DIR}/PolChemDefRendering.cpp
    ${GUI_DIR}/PolChemDefWnd.cpp
    ${GUI_DIR}/PolymerModificationDlg.cpp
    ${GUI_DIR}/RegionSelection.cpp
    #
    ${GUI_DIR}/SeqToolsDlg.cpp
    ${GUI_DIR}/SequenceEditorFindDlg.cpp
    ${GUI_DIR}/SequenceEditorGraphicsView.cpp
    ${GUI_DIR}/SequenceEditorGraphicsViewKeySequenceHandling.cpp
    ${GUI_DIR}/SequenceEditorGraphicsViewKeyboardHandling.cpp
    ${GUI_DIR}/SequenceImportDlg.cpp
    ${GUI_DIR}/SequencePurificationDlg.cpp
    ${GUI_DIR}/SequenceSelection.cpp
)

set(${TARGET}_UIS
    ${GUI_DIR}/ui/AboutDlg.ui
    ${GUI_DIR}/ui/ApplicationPreferencesWnd.ui
    ${GUI_DIR}/ui/ApplicationPreferencesWndGeneralPageWidget.ui
    ${GUI_DIR}/ui/MaxThreadCountPreferencesWidget.ui
    ${GUI_DIR}/ui/FileSystemHierarchyPreferencesWidget.ui
    ${GUI_DIR}/ui/AbstractPolChemDefDependentDlg.ui
    ${GUI_DIR}/ui/CalculatorChemPadDlg.ui
    ${GUI_DIR}/ui/CalculatorRecorderDlg.ui
    ${GUI_DIR}/ui/CalculatorWnd.ui
    ${GUI_DIR}/ui/CleavageDlg.ui
    ${GUI_DIR}/ui/CleavageAgentDefDlg.ui
    ${GUI_DIR}/ui/CompositionsDlg.ui
    ${GUI_DIR}/ui/ConfigSettingsDlg.ui
    ${GUI_DIR}/ui/CrossLinkerDefDlg.ui
    ${GUI_DIR}/ui/DecimalPlacesOptionsDlg.ui
    ${GUI_DIR}/ui/DecimalPlacesPreferencesWidget.ui
    ${GUI_DIR}/ui/FragmentationPathwayDefDlg.ui
    ${GUI_DIR}/ui/FragmentationDlg.ui
    ${GUI_DIR}/ui/IsotopeDefDlg.ui
    ${GUI_DIR}/ui/JavaScriptingWnd.ui
    ${GUI_DIR}/ui/MassSearchDlg.ui
    ${GUI_DIR}/ui/ModifDefDlg.ui
    ${GUI_DIR}/ui/MonomerCrossLinkDlg.ui
    ${GUI_DIR}/ui/MonomerDefDlg.ui
    ${GUI_DIR}/ui/MonomerModificationDlg.ui
    ${GUI_DIR}/ui/MzCalculationDlg.ui
    ${GUI_DIR}/ui/MzLabFormulaBasedActionsDlg.ui
    ${GUI_DIR}/ui/MzLabInputOligomerTableViewDlg.ui
    ${GUI_DIR}/ui/MzLabMassBasedActionsDlg.ui
    ${GUI_DIR}/ui/MzLabMatchBasedActionsDlg.ui
    ${GUI_DIR}/ui/MzLabOutputOligomerTableViewDlg.ui
    ${GUI_DIR}/ui/MzLabWnd.ui
    ${GUI_DIR}/ui/NumeralsLocaleConverterDlg.ui
    ${GUI_DIR}/ui/PkaPhPiDlg.ui
    ${GUI_DIR}/ui/PolChemDefWnd.ui
    ${GUI_DIR}/ui/PolymerModificationDlg.ui
    ${GUI_DIR}/ui/SequenceEditorFindDlg.ui
    ${GUI_DIR}/ui/SequenceEditorWnd.ui
    ${GUI_DIR}/ui/SequenceImportDlg.ui
    ${GUI_DIR}/ui/SequencePurificationDlg.ui
)

set(CMAKE_AUTOUIC_SEARCH_PATHS ${GUI_DIR}/ui)

qt_standard_project_setup(REQUIRES 6.5)

qt6_add_resources(${TARGET}_qrc_CPP ../${TARGET}.qrc)

###############################################################
# Configuration of the binary to be built
###############################################################

message(STATUS "CMAKE_CURRENT_SOURCE_DIR: ${CMAKE_CURRENT_SOURCE_DIR}")

include_directories(
    # The config file is binary directory-specific !!!
    # For the config.h file generated from config.h.cmake.in
    # For the ui_Xyyyyy.h files
    ${CMAKE_CURRENT_BINARY_DIR}
    # For all the source subdirectories
    ${NONGUI_DIR} ${GUI_DIR}
)

# Only now can we add the executable, because we have defined the sources of the
# object library above.

if(WIN32 OR _WIN32)

    qt_add_executable(
        ${TARGET}
        main.cpp
        ${${TARGET}_nongui_SRCS}
        ${${TARGET}_gui_SRCS}
        ${${TARGET}_UIS}
        ${${TARGET}_qrc_CPP}
        ${PLATFORM_SPECIFIC_SOURCES}
        #${CMAKE_SOURCE_DIR}/${PROJECT_NAME}.rc
    )

    # # Required for Windows 10/11
    # Well, this is what I thought. In fact, the program would not run on Win11
    # not because the linker options below were not set, but because the Win11
    # system what a family edition. I know the software runs with the stuff below
    # on Win11 pro system right.
    # FURTHER, since I have added the linker options below the program does
    # not start anymore on Win11 pro machines with infamous error:
    # 0xc000007b. Removing the lines below make MassXpert3 run on Win11 pro
    # again.
    # target_link_options(${TARGET} PRIVATE
    #     # Set OS version to Windows 10
    #     "-Wl,--major-os-version=10"
    #     "-Wl,--minor-os-version=0"
    #     # Set subsystem version
    #     "-Wl,--major-subsystem-version=10"
    #     "-Wl,--minor-subsystem-version=0"
    #     # Ensure modern subsystem
    #     "-Wl,--subsystem,windows:10.0"
    # )

    # In Debug mode we want the console to be opened so that we can read the debug
    # messages. But in Release mode the console is not desirable (the snippet
    # below removes it).
    if(CMAKE_BUILD_TYPE STREQUAL "Release")
        set_property(TARGET ${TARGET} PROPERTY WIN32_EXECUTABLE true)
    endif()

elseif(UNIX)

    qt_add_executable(
        ${TARGET}
        main.cpp
        ${${TARGET}_nongui_SRCS}
        ${${TARGET}_gui_SRCS}
        ${${TARGET}_UIS}
        ${${TARGET}_qrc_CPP}
        ${PLATFORM_SPECIFIC_SOURCES}
    )

endif()

# Finally actually set the linking dependencies to the executable.
# Note that there are so many cross-dependencies that it is virtually unfeasible
# to actually link the binary without resorting to the linker dance steps below.

# Still, I discovered that the order below is good with respect of the symbols
# dependencies resolutions when linking

# The general idea is to first list the libraries that *use* symbols and later
# libraries that *provide* symbols. Which is why all the Qt libs are listed at
# the end and the private libs are listed first.
target_link_libraries(
    ${TARGET}
    PRIVATE -Wl,--no-as-needed
            XpertMass::Core
            XpertMass::Gui
            -Wl,--as-needed
            -Wl,--no-as-needed
            PappsoMSpp::Core
            -Wl,--as-needed
            -Wl,--no-as-needed
            PappsoMSpp::Gui
            -Wl,--as-needed
            -Wl,--no-as-needed
            IsoSpec++::IsoSpec++
            -Wl,--as-needed
            -Wl,--no-as-needed
            QScintilla::QScintilla
            -Wl,--as-needed
            Qt6::Widgets
            Qt6::Svg
            Qt6::SvgWidgets
            Qt6::PrintSupport
            Qt6::Xml
            Qt6::Network
            Qt6::Qml
            #
            # This is the object file obtained my compiling
            # the WindRes resource file using windres.exe
            # See corresponding MXE or WIN10UCRT64 toolchains.
            ${PLATFORM_SPECIFIC_LIB_FILES}
)

if(PROFILING)
    message(STATUS "Profiling is requested, adding linker -pg flag.")
    set(CMAKE_EXE_LINKER_FLAGS "-pg")
    target_link_options(${TARGET} PRIVATE -pg)
endif()

# These options allow for printing messages to the console from
# which the program is run (for example, in Linux, with wine MineXpert3).
if(WIN32)
    target_link_options(${TARGET} PRIVATE "-Wl,--subsystem,console")
endif()

# We want to install the binary arch-dependent target in
# specific situations. To have proper control, we define the arch
# component.
install(
    TARGETS ${TARGET}
    RUNTIME COMPONENT arch DESTINATION ${PROJECT_INSTALL_BIN_DIR}
)

message("")
message("\n${BoldGreen}Ending configuration for subdirectory src${ColourReset}\n")
message("")

=== doc/user-manual/CMakeLists.txt ===
message("\n${BoldGreen}Configuring subdirectory doc/user-manual${ColourReset}\n")

message("")
message("\n${BoldYellow}Configuring the user manual compilation${ColourReset}\n")
message("")

# The file driving the user manual build is DC-user-manual.
# This file contains a config bit that points to the directory
# that contains de fop.xconf configuration file needed by
# the FOP utility that crafts the user manual pdf file.

set(FOP_XCONF_DIR ${CMAKE_SOURCE_DIR}/doc/user-manual)
configure_file(
    ${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual @ONLY
)

message("\tConfiguring the user manual compilation")

# The output of Daps will be in BUILD_DIR.
add_custom_target(
    user-manual ALL
    COMMAND make BUILD_DIR=${CMAKE_BINARY_DIR}/doc -f usermanual-makefile all_f
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc/user-manual
    COMMENT "Build of the DocBook-based user manual \
      documentation in ${CMAKE_BINARY_DIR}/doc"
)

set(DOC_STORE_PATH "${HOME_DEVEL_DIR}/msxpertsuite-store/docs/${LOWCASE_PROJECT_NAME_NO_VER}")

if(DEFINED ENV{DEB_BUILD_OPTIONS})

    message("Building debian package: not sychronizing documentation to doc store.")

else()

    # We want to store a local copy of the documentation so that we do not mess around
    # with build in unix that destroy the documentation if the build user manual switch
    # is not set and then MXE fails to find the doc pdf file.
    add_custom_command(
        TARGET user-manual
        POST_BUILD
        COMMAND rsync -avpP --delete ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}-doc.pdf ${CMAKE_CURRENT_BINARY_DIR}/html
                ${DOC_STORE_PATH}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        COMMENT "Copy the documentation to ${DOC_STORE_PATH}"
    )

endif()


install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}-doc.pdf
    DESTINATION ${PROJECT_INSTALL_DOC_DIR}
)

install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/user-manual/
    DESTINATION ${PROJECT_INSTALL_DOC_DIR}/html
)

message("")
message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
message("")

message("\n${BoldGreen}Done configuring subdirectory doc/user-manual${ColourReset}\n")

=== debian/changelog ===
massxpert3 (10.4.0-1) unstable; urgency=low

  * New release with new ApplicationPreferencesWnd-associated features.

  * Depends on more recent libpappsomspp and libxpertmass.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 21 Feb 2026 15:45:35 +0100

massxpert3 (10.3.0-1) unstable; urgency=low

  * New release with reworked QSettings-based configuration and an
    implementation of the 'Recent files... ' menu.

  * Small bug fixes.

  * Depends on more recent libpappsomspp and libxpertmass.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 18 Dec 2025 19:31:40 +0100

massxpert3 (10.2.0-1) unstable; urgency=low

  * New release with new feature to allow phasing the bins in multiple
    isotopic cluster mass spectra combinations.

  * Update the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 04 Dec 2025 23:50:31 +0100

massxpert3 (10.1.2-1) unstable; urgency=low

  * New release depending on new version of XpertMass (bug fix over there).

  * General review of the user manual and update with the new documentation
    about the JavaScript features.

  * Overhaul of the org.msxpertsuite.MassXpert3.metainfo.xml file. Update
    of the links to screenshots.

  * Redone all the identity artwork (icons and splashscren).

  * Update the build-dependencies over libraries.

  * Remove build-dep on imagemagick-6-common. We'll see.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 21 Nov 2025 23:05:11 +0100

massxpert3 (10.1.1-1) unstable; urgency=low

  * New release fixing the versioning in the user manual
    user-manual-version-entity.ent file.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 30 Oct 2025 00:13:41 +0100

massxpert3 (10.1.0-1) UNRELEASED; urgency=low

  * New release with a bunch of dependee updates (libpwizlite,
    libisospec, libpappsomspp).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 29 Oct 2025 23:24:09 +0100

massxpert3 (10.0.0-1) unstable; urgency=low

  * New release of version 10.0.0, the first version of massxpert3 series.
    This is a full rewrite of MassXpert as software that depends on the
    libXpertMassCore and libXpertMassGui libraries which have been fully
    rewritten.
  * JavaScript-based scripting is now possible thanks to the JS scripting
    abilities of these two libraries.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 29 May 2025 12:34:10 +0200

massxpert3 (8.6.0-1) UNRELEASED; urgency=low

  * Mainly build system improvements.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 22 Jul 2024 12:48:40 +0200

massxpert3 (8.5.0-1) unstable; urgency=low

  * Big new upstream version that now relies on shared libraries
    libxpertmass and libxpertmass-gui instead of having the two
    static libraries made inside the source tree.

    Thus, now depends on libxpertmass-dev (>= 1.0.0).

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 22 Jul 2024 12:48:40 +0200

massxpert3 (8.4.1-1) unstable; urgency=low

  * Small fixes.
  * Update dependency version for libpappsomspp.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 01 Jun 2024 13:52:44 +0200

massxpert3 (8.4.0-1) unstable; urgency=low

  * Add new polymer chemistry definition for fully labelled N;
  * Improve the ChemicalPad config for some sugars;
  * Implemented basic functionality in Averagine;
  * Allow using a double as a count for the formula;
  * Implemented the formula checkSyntax function using a RegularExpression;
  * Reconfigure the source tree to accomodate libmass and libmassgui
    as true git submodules;
  * MXE-based build works flawlessly;
  * Network-based communications between mineXpert2 and massXpert2
    now work perfectly;
  * Updated the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 02 May 2024 14:11:55 +0200

massxpert3 (8.3.1-1) unstable; urgency=low

  * Rework the user manual build system.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 07 Dec 2023 12:17:36 +0100

massxpert3 (8.3.0-1) unstable; urgency=low

  * New upstream version:

    * New polymer chemistry definition with 98% labelled C13 and N15.
    * Fix crash with QTimer triggering single shot after its destruction.
    * Code cleanup and fix to memory leak in client-server code.
    * Compile the user manual in the binary source tree

  * Standards-Version: 4.6.2

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 21 Nov 2023 16:23:48 +0100

massxpert3 (8.2.0-1) unstable; urgency=low

  * New upstream package.

  * Two metapackages ensure that an upgrade of massxpert (or massxpert-doc)
    pulls in the new packages.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 23 Jun 2023 16:37:54 +0200

massxpert3 (8.1.0-1) unstable; urgency=low

  * New upstream version featuring the dynamic loading of isotopic data from
    disk files in the sequence editor, the cleavage dialog window and the
    fragmentation dialog window.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 20 Jun 2023 17:23:30 +0200

massxpert3 (8.0.1-1) unstable; urgency=low

  * New upstream version fixing bug with synthetic mass spectrum
    normalization.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 27 Apr 2023 13:34:52 +0200

massxpert3 (8.0.0-1) unstable; urgency=low

  * Rename the software massXpert -> massXpert2.

  * Refactoring all the framework describing the chemical entities: abandoned
    the Atom/AtomCount paradigm in favor of a complete list of isotopes
    (IsotopicData). This works aims at streamlining all the future features
    related to isotopic cluster modelling.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 16 Feb 2023 13:07:18 +0100

massxpert (7.1.0-1) unstable; urgency=low

  * New version implementing a new project hierarchy: libmass and libmassgui
    private static libraries enshrine all the functionalities that might be
    used in other project. The implementation is based on git submodules.

  * Added the possibility to perform isotopic cluster calculations and mass
    peak shape calculations.

  * Added build dependencies for the new features.



=== debian/control ===
Source: massxpert3
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 13),
 dpkg-dev (>= 1.21.22),
# To export from svg to png
 librsvg2-bin,
 qt6-base-dev,
 libqt6svg6-dev,
 qt6-declarative-dev,
 libqt6core5compat6-dev,
 libxkbcommon-x11-dev,
 cmake,
 daps,
 libjs-jquery,
 libjs-highlight.js,
 texlive-fonts-extra,
 fonts-ebgaramond-extra,
 fonts-urw-base35,
# Only the logically essential one.
 libpappsomspp-gui-dev (>= 0.11.10),
# Only the logically essential one.
 libxpertmassgui-dev (>= 1.8.1),
 libqscintilla2-qt6-dev,
 libisospec++-dev (>=2.3.1),
 libpwizlite-dev,
 libsqlite3-dev,
 libzstd-dev,
 liblzf-dev,
 zlib1g-dev,
 libquazip1-qt6-dev,
 libqcustomplot-dev (>= 2.1.0),
 libodsstream-dev (>= 0.9.14),
 libboost1.88-dev,
 libboost-thread1.88-dev,
 libboost-system1.88-dev,
 libboost-filesystem1.88-dev,
 libboost-iostreams1.88-dev,
 libboost-chrono1.88-dev,
 libboost-random1.88-dev,
 libboost-container1.88-dev,
 docbook-xml,
 docbook-to-man
Standards-Version: 4.7.2
Homepage: http://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/massxpert3
Vcs-Git: https://salsa.debian.org/debichem-team/massxpert3.git
Rules-Requires-Root: no

Package: massxpert2
Depends: massxpert3,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for massxpert2 -> massxpert3
 This is a transitional package. It can safely be removed.
 Runtime package.

Package: massxpert2-data
Depends: massxpert3-data,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for massxpert2-dat -> massxpert3-data
 This is a transitional package. It can safely be removed.
 Runtime package.


Package: massxpert-doc
Depends: massxpert3-doc,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for massxpert-doc -> massxpert3-doc
 This is a transitional package. It can safely be removed.
 Documentation package.


Package: massxpert2-doc
Depends: massxpert3-doc,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for massxpert2-doc -> massxpert3-doc
 This is a transitional package. It can safely be removed.
 Documentation package.


Package: massxpert3
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         massxpert3-data (>= ${source:Upstream-Version})
Suggests: massxpert3-doc (>= ${source:Upstream-Version})
Replaces: massxpert, massxpert2
Breaks: massxpert, massxpert2
Description: polymer chemistry modelling and mass spectrometry data simulation (runtime)
 MassXpert3 allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
  - Perform isotopic cluster simulations.
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the massXpert3 program.


Package: massxpert3-data
Architecture: all
Depends: ${misc:Depends},
Suggests: massxpert3-doc (>= ${source:Upstream-Version})
Replaces: massxpert2-data
Breaks: massxpert2-data
Description: polymer chemistry modelling and mass spectrometry data simulation (data)
 MassXpert3 allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
  - Perform isotopic cluster simulations.
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the polymer chemistry data.


Package: massxpert3-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Replaces: massxpert2-doc
Breaks: massxpert2-doc
Description: polymer chemistry modelling and mass spectrometry data simulation (doc)
 MassXpert3 allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
  - Perform isotopic cluster simulations.
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the user manual in both PDF and HTML formats.

=== debian/rules ===
#!/usr/bin/make -f
# Based on the initial work of Joey Hess and Craig Small.

# Include for DEB_VERSION_UPSTREAM below
include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

# Set path to this directory so that our tweaked fop script is used.
PATH := $(CURDIR)/doc/user-manual/scripts:$(PATH)
$(info PATH: $(PATH))


%:
	dh $@

# Required to stop it from calling my convenience Makefile that is only used for
# my day-to-day work.
override_dh_auto_clean:

override_dh_clean:
	dh_clean
	rm -rf debian/build
	rm -rf debian/tmp
	rm -f compile_commands.json
	rm -f doc/user-manual/DC-user-manual
	rm -f doc/user-manual/MassXpert3-doc.pdf

override_dh_auto_configure:
	mkdir -p debian/build
	mkdir -p debian/tmp
	cd debian/build && cmake -DCMAKE_BUILD_TYPE=Release -DBUILD_USER_MANUAL=1 -DCMAKE_INSTALL_PREFIX=/usr ../..

override_dh_auto_build:
	cd debian/build && make

override_dh_compress:
	dh_compress -X.pdf

override_dh_auto_install:
	cd debian/build && DESTDIR=../tmp make install
	dh_install
